<?php

/**
 * JLangUrlManager class file.
 *
 * @author jerry2801 <jerry2801@gmail.com>
 * @version 1.0
 *
 */

class JLangUrlManager extends CUrlManager
{
    public $langParam = 'lang';

    /**
     * Get All Languages
     *
     * 'en_us' => array(
     *     'label'=>'English',
     *     'dateFormat'=>'d-M-Y',
     * ),
     * 'zh_cn' => array(
     *     'label'=>'中文',
     *     'dateFormat'=>'Y-m-d',
     * ),
     *
     */
    public function getLanguages()
    {
        return include Yii::app()->basePath.DIRECTORY_SEPARATOR.'config'.DIRECTORY_SEPARATOR.'languages.php';
    }

    public function parseUrl($request)
    {
        $languages=$this->languages;
        $ret=parent::parseUrl($request);


        if(isset($_GET[$this->langParam]) && isset($languages[ $_GET[$this->langParam] ]))
            Yii::app()->language=$_GET[$this->langParam];
        else
        {
            $preferredLanguage=Yii::app()->getRequest()->getPreferredLanguage();
            if(isset($languages[ $preferredLanguage ]))
                Yii::app()->language=$preferredLanguage;
            else
            {
                $languageKeys=array_keys($languages);
                Yii::app()->language = reset($languageKeys);
            }
        }
        
        return $ret;
    }

    public function createUrl($route, $params=array(), $ampersand='&')
    {
        if(!isset($params[$this->langParam])) $params[$this->langParam]=Yii::app()->language;
        return parent::createUrl($route,$params,$ampersand);
    }

}